#include "ti82.h"
#include "keys.inc"

   .org START_ADDR
   .db  "Volume&Rotation",0
   
start:
  call sub0
  ld   hl,text1
  call sub1
  ld   hl,text2
  call sub2
  ld   hl,text3
  call sub4
  ld   hl,text4
  call sub6
  ld   hl,text5
  call sub7
  ld   hl,text6
  ROM_CALL(D_ZT_STR)

geta:
  call GET_KEY
  cp   G_ENTER
  jp   z,label_y
  jr   geta

label_y:
  call sub0
  ld   hl,text7
  call sub1
  ld   hl,text8
  call sub2
  ld   hl,text9
  call sub3
  ld   hl,text10
  call sub4
  ld   hl,text11
  call sub5
  ld   hl,text12
  call sub7
  ld   hl,text14
  ROM_CALL(D_ZT_STR)
      
get1:
  call GET_KEY
  cp   G_YEDIT
  jp   z,label_a
  cp   G_WINDOW
  jp   z,label_a
  cp   G_ZOOM
  jp   z,label_c
  cp   G_TRACE
  jp   z,label_d
  cp   G_CLEAR
  jp   z,label_z
  jr   get1
  
label_a:
  call sub0
  ld   hl,text15
  call sub1
  ld   hl,text16
  call sub7
  ld   hl,text17
  ROM_CALL(D_ZT_STR)
  
get2:
  call GET_KEY
  cp   G_YEDIT
  jp   z,label_aa
  cp   G_WINDOW
  jp   z,label_ab
  cp   G_CLEAR
  jp   z,label_z
  jr   get2

label_aa:
  call sub0
  ld   hl,text22
  jr   get3

label_ab:
  call sub0
  ld   hl,text23
  
get3:
  call sub7
  ld   hl,text26
  ROM_CALL(D_ZT_STR)
  call GET_KEY
  cp   G_YEDIT
  jp   z,label_y
  cp   G_CLEAR
  jp   z,label_z
  jr   get3

label_c:
  call sub0
  ld   hl,text15
  call sub1
  ld   hl,text16
  call sub7
  ld   hl,text17
  ROM_CALL(D_ZT_STR)
  
get4:
  call GET_KEY
  cp   G_YEDIT
  jp   z,label_ca
  cp   G_WINDOW
  jp   z,label_cb
  cp   G_CLEAR
  jp   z,label_z
  jr   get4

label_ca:
  call sub0
  ld   hl,text24
  jr   get3

label_cb:
  call sub0
  ld   hl,text25
  jr   get3

label_d:
  call sub0
  ld   hl,text15
  call sub1
  ld   hl,text16
  call sub7
  ld   hl,text17
  ROM_CALL(D_ZT_STR)
  
get6:
  call GET_KEY
  cp   G_YEDIT
  jp   z,label_da
  cp   G_WINDOW
  jp   z,label_db
  cp   G_CLEAR
  jp   z,label_z
  jr   get6

label_da:
  call sub0
  ld   hl,text24
  jp   get3

label_db:
  call sub0
  ld   hl,text23
  jp   get3

sub0:
  ROM_CALL(CLEARLCD)
  ld   de,$0000
  ld   (CURSOR_ROW),de
  ret

sub1:
  ROM_CALL(D_ZT_STR)
  ld   de,$0001
  ld   (CURSOR_ROW),de
  ret

sub2:
  ROM_CALL(D_ZT_STR)
  ld   de,$0002
  ld   (CURSOR_ROW),de
  ret

sub3:
  ROM_CALL(D_ZT_STR)
  ld   de,$0003
  ld   (CURSOR_ROW),de
  ret

sub4:
  ROM_CALL(D_ZT_STR)
  ld   de,$0004
  ld   (CURSOR_ROW),de
  ret

sub5:
  ROM_CALL(D_ZT_STR)
  ld   de,$0005
  ld   (CURSOR_ROW),de
  ret

sub6:
  ROM_CALL(D_ZT_STR)
  ld   de,$0006
  ld   (CURSOR_ROW),de
  ret

sub7:
  ROM_CALL(D_ZT_STR)
  ld   de,$0007
  ld   (CURSOR_ROW),de
  ret    

label_z:
  ret

text1:
.db "VOLUME&ROTATION",0
text2:
.db "OF A SOLID",0
text3:
.db "V1.0",0
text4:
.db "(C) 2002",0
text5:
.db "WILSON NG",0
text6:
.db "WAESH@YAHOO",0
text7:
.db "ROTATION ACROSS",0
text8:
.db " WHAT?",0
text9:
.db "1) X-AXIS",0
text10:
.db "2) Y-AXIS",0
text11:
.db "3) X=?",0
text12:
.db "4) Y=?",0
text14:
.db " 1  2   3  4",0
text15:
.db "SPACE BETWEEN",0
text16:
.db " ROTATION?",0
text17:
.db "YES NO",0
text22:
.db "T2-B2",0
text23:
.db "(T-B)2",0
text24:
.db "(T-A)2-(B-A)2",0
text25:
.db "(A-T)2",0
text26:
.db "AGAIN",0

.end

